/*
 * veraweb,
 * Veranstaltungsmanagment veraweb
 * Copyright (c) 2005-2007 tarent GmbH
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License,version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 *
 * tarent GmbH., hereby disclaims all copyright
 * interest in the program 'veraweb'
 * Signature of Elmar Geese, 21 November 2007
 * Elmar Geese, CEO tarent GmbH.
 */

/*
 * $Id: Exchanger.java,v 1.1 2007/06/20 11:56:52 christoph Exp $
 * 
 * Created on 22.08.2005
 */
package de.tarent.data.exchange;

import java.io.InputStream;
import java.io.OutputStream;

/**
 * Diese Schnittstelle beschreibt Grundfunktionen einer Datenaustauschklasse,
 * also eines {@link de.tarent.aa.veraweb.utils.Exporter Exporters} oder
 * {@link de.tarent.aa.veraweb.utils.Importer Importers}. Diese dienen im
 * Wesentlichen dazu, diesem Informationen zum Datenaustauschformat und zu
 * den beteiligten Datenstrmen zu geben. 
 * 
 * @author mikel
 */
public interface Exchanger {
    //
    // Getter und Setter
    //
    /** Das zu verwendende Austauschformat */
    ExchangeFormat getExchangeFormat();
    /** Das zu verwendende Austauschformat */
    void setExchangeFormat(ExchangeFormat format);
    
    /** Der zu verwendende Eingabedatenstrom */
    InputStream getInputStream();
    /** Der zu verwendende Eingabedatenstrom */
    void setInputStream(InputStream stream);
    
    /** Der zu verwendende Ausgabedatenstrom */
    OutputStream getOutputStream();
    /** Der zu verwendende Ausgabedatenstrom */
    void setOutputStream(OutputStream stream);
}
